diff -u -r linux.clean/drivers/scsi/scsi.c linux.new2/drivers/scsi/scsi.c
--- linux.clean/drivers/scsi/scsi.c	Tue Jun  8 13:41:03 1999
+++ linux.new2/drivers/scsi/scsi.c	Sun Sep  5 09:07:40 1999
@@ -313,6 +313,7 @@
     return 0;
 }
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
 /*
  * Function:    scsi_make_blocked_list
  *
@@ -392,6 +393,7 @@
     }
 
 }
+#endif
 
 static void scan_scsis_done (Scsi_Cmnd * SCpnt)
 {
@@ -457,6 +459,18 @@
   SDpnt = (Scsi_Device *) scsi_init_malloc (sizeof (Scsi_Device), GFP_ATOMIC);
   memset (SDpnt, 0, sizeof (Scsi_Device));
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  /*
+   * Register the queue for the device.  All I/O requests will come
+   * in through here.  We also need to register a pointer to
+   * ourselves, since the queue handler won't know what device
+   * the queue actually represents.   We could look it up, but it
+   * is pointless work.
+   */
+  blk_init_queue(&SDpnt->request_queue, scsi_request_fn);
+  blk_queue_headactive(&SDpnt->request_queue, 0);
+  SDpnt->request_queue.queuedata = (void *) SDpnt;
+#endif
 
   /* Make sure we have something that is valid for DMA purposes */
   scsi_result = ( ( !shpnt->unchecked_isa_dma )
@@ -476,6 +490,10 @@
   SDpnt->host = shpnt;
   SDpnt->online = TRUE;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  initialize_merge_fn(SDpnt);
+#endif
+
   init_waitqueue_head(&SDpnt->device_wait);
 
   /*
@@ -520,7 +538,9 @@
     for(sdtpnt = scsi_devicelist; sdtpnt; sdtpnt = sdtpnt->next)
         if(sdtpnt->init && sdtpnt->dev_noticed) (*sdtpnt->init)();
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
             oldSDpnt->scsi_request_fn = NULL;
+#endif
             for(sdtpnt = scsi_devicelist; sdtpnt; sdtpnt = sdtpnt->next)
                 if(sdtpnt->attach) {
 		  (*sdtpnt->attach)(oldSDpnt);
@@ -651,9 +671,12 @@
    * Assume that the device will have handshaking problems, and then fix this
    * field later if it turns out it doesn't
    */
-  SDpnt->borken = 1;
-  SDpnt->was_reset = 0;
+  SDpnt->borken          = 1;
+  SDpnt->was_reset       = 0;
   SDpnt->expecting_cc_ua = 0;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  SDpnt->starved         = 0;
+#endif
 
   scsi_cmd[0] = TEST_UNIT_READY;
   scsi_cmd[1] = lun << 5;
@@ -668,11 +691,15 @@
     DECLARE_MUTEX_LOCKED(sem);
     SCpnt->request.sem = &sem;
     SCpnt->request.rq_status = RQ_SCSI_BUSY;
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irq(&io_request_lock);
+#endif
     scsi_do_cmd (SCpnt, (void *) scsi_cmd,
                  (void *) NULL,
                  0, scan_scsis_done, SCSI_TIMEOUT + 4 * HZ, 5);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irq(&io_request_lock);
+#endif
     down (&sem);
     SCpnt->request.sem = NULL;
   }
@@ -711,11 +738,15 @@
     DECLARE_MUTEX_LOCKED(sem);
     SCpnt->request.sem = &sem;
     SCpnt->request.rq_status = RQ_SCSI_BUSY;
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irq(&io_request_lock);
+#endif
     scsi_do_cmd (SCpnt, (void *) scsi_cmd,
                  (void *) scsi_result,
                  256, scan_scsis_done, SCSI_TIMEOUT, 3);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irq(&io_request_lock);
+#endif
     down (&sem);
     SCpnt->request.sem = NULL;
   }
@@ -857,11 +888,15 @@
       DECLARE_MUTEX_LOCKED(sem);
       SCpnt->request.rq_status = RQ_SCSI_BUSY;
       SCpnt->request.sem = &sem;
+#ifndef CONFIG_SCSI_NEW_QUEUES
       spin_lock_irq(&io_request_lock);
+#endif
       scsi_do_cmd (SCpnt, (void *) scsi_cmd,
                    (void *) scsi_result, 0x2a,
                    scan_scsis_done, SCSI_TIMEOUT, 3);
+#ifndef CONFIG_SCSI_NEW_QUEUES
       spin_unlock_irq(&io_request_lock);
+#endif
       down (&sem);
       SCpnt->request.sem = NULL;
     }
@@ -888,6 +923,21 @@
 
   memset (SDpnt, 0, sizeof (Scsi_Device));
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  /*
+   * Register the queue for the device.  All I/O requests will come
+   * in through here.  We also need to register a pointer to
+   * ourselves, since the queue handler won't know what device
+   * the queue actually represents.   We could look it up, but it
+   * is pointless work.
+   */
+  blk_init_queue(&SDpnt->request_queue, scsi_request_fn);
+  blk_queue_headactive(&SDpnt->request_queue, 0);
+  SDpnt->request_queue.queuedata = (void *) SDpnt;
+  SDpnt->host = shpnt;
+  initialize_merge_fn(SDpnt);
+#endif
+
   /*
    * And hook up our command block to the new device we will be testing
    * for.
@@ -977,7 +1027,7 @@
  * turned off when entering the routine.  It is the responsibility
  * of the calling code to ensure that this is the case.
  */
-
+#ifndef CONFIG_SCSI_NEW_QUEUES
 Scsi_Cmnd * scsi_request_queueable (struct request * req, Scsi_Device * device)
 {
     Scsi_Cmnd * SCpnt = NULL;
@@ -1091,6 +1141,7 @@
 
     return SCpnt;
 }
+#endif
 
 /* This function returns a structure pointer that will be valid for
  * the device.  The wait parameter tells us whether we should wait for
@@ -1101,7 +1152,134 @@
  * scsi_request_queueable function also knows the internal allocation scheme
  * of the packets for each device
  */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+/*
+ * This lock protects the freelist for all devices on the system.
+ * We could make this finer grained by having a single lock per
+ * device if it is ever found that there is excessive contention
+ * on this lock.
+ */
+static spinlock_t device_request_lock = SPIN_LOCK_UNLOCKED;
+
+/*
+ * Used for access to internal allocator used for DMA safe buffers.
+ */
+static spinlock_t allocator_request_lock = SPIN_LOCK_UNLOCKED;
+
+/*
+ * Used to protect insertion into and removal from the queue of
+ * commands to be processed by the bottom half handler.
+ */
+static spinlock_t scsi_bhqueue_lock      = SPIN_LOCK_UNLOCKED;
+
+/*
+ * Function:    scsi_allocate_device
+ *
+ * Purpose:     Allocate a command descriptor.
+ *
+ * Arguments:   device    - device for which we want a command descriptor
+ *		wait      - 1 if we should wait in the event that none
+ *                          are available.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Pointer to command descriptor.
+ *
+ * Notes:	Prior to the new queue code, this function was not SMP-safe.
+ */
+Scsi_Cmnd * scsi_allocate_device (Scsi_Device * device, int wait)
+{
+    struct Scsi_Host * host;
+    Scsi_Cmnd * SCpnt = NULL;
+    unsigned long flags;
+
+    if (!device)
+	panic ("No device passed to scsi_allocate_device().\n");
+
+    host = device->host;
+
+    spin_lock_irqsave(&device_request_lock, flags);
+
+    while(1==1)
+    {
+        SCpnt = NULL;
+        if( !device->device_blocked )
+        {
+            if (!device->single_lun) 
+            {
+                for(SCpnt = device->device_queue; SCpnt; SCpnt = SCpnt->next)
+                {
+                    if(SCpnt->request.rq_status == RQ_INACTIVE) break;
+                }
+            }
+            else
+            {
+                /*
+                 * FIXME(eric) - the single_lun code is broken.  Each
+                 * device has it's own list of commands, and seaching this
+                 * device won't find commands active on another lun
+                 */
+                panic("single_lun not supported");
+            }
+        }
 
+        /*
+         * If we couldn't find a free command block, and we have been
+         * asked to wait, then do so.
+         */
+        if (SCpnt)
+        {
+            break;
+        }
+         
+        /*
+         * If we have been asked to wait for a free block, then
+         * wait here.
+         */
+        spin_unlock_irqrestore(&device_request_lock, flags);
+        if( wait )
+        {
+            /*
+             * This should block until a device command block
+             * becomes available.
+             */
+            sleep_on(&device->device_wait);
+            spin_lock_irqsave(&device_request_lock, flags);
+        }
+        else
+        {
+            return NULL;
+        }
+    }
+        
+    SCpnt->request.rq_status = RQ_SCSI_BUSY;
+    SCpnt->request.sem = NULL;   /* And no one is waiting for this
+                                  * to complete */
+    atomic_inc(&SCpnt->host->host_active); 
+    
+    SCpnt->use_sg = 0;            /* Reset the scatter-gather flag */
+    SCpnt->old_use_sg  = 0;
+    SCpnt->transfersize = 0;      /* No default transfer size */
+    SCpnt->cmd_len = 0;
+    
+    SCpnt->underflow = 0;         /* Do not flag underflow conditions */
+    SCpnt->state = SCSI_STATE_INITIALIZING;
+    SCpnt->owner = SCSI_OWNER_HIGHLEVEL;
+
+    spin_unlock_irq(&device_request_lock);
+
+    SCSI_LOG_MLQUEUE(5, printk("Activating command for device %d (%d)\n", 
+                               SCpnt->target,
+                               atomic_read(&SCpnt->host->host_active)));
+
+    return SCpnt;
+}
+#else
+/*
+ * This is the old version of scsi_allocate_device that was used prior to
+ * the new queue code.   It is essentially unchanged, and it is *NOT*
+ * SMP-safe.
+ */
 Scsi_Cmnd * scsi_allocate_device (struct request ** reqp, Scsi_Device * device,
 			     int wait)
 {
@@ -1253,6 +1431,7 @@
 
     return SCpnt;
 }
+#endif
 
 /*
  * Function:    scsi_release_command
@@ -1268,6 +1447,11 @@
 void
 scsi_release_command(Scsi_Cmnd * SCpnt)
 {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  unsigned long flags;
+  spin_lock_irqsave(&device_request_lock, flags);
+#endif
+
   SCpnt->request.rq_status = RQ_INACTIVE;
   SCpnt->state = SCSI_STATE_UNUSED;
   SCpnt->owner = SCSI_OWNER_NOBODY;
@@ -1296,12 +1480,134 @@
                                  atomic_read(&SCpnt->host->eh_wait->count)));
       up(SCpnt->host->eh_wait);
   }
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_unlock_irqrestore(&device_request_lock, flags);
+#endif
 }
 
 /*
  * This is inline because we have stack problemes if we recurse to deeply.
  */
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+int scsi_dispatch_cmd (Scsi_Cmnd * SCpnt)
+{
+#ifdef DEBUG_DELAY
+    unsigned long clock;
+#endif
+    struct Scsi_Host   * host;
+    int                  rtn = 0;
+    unsigned long        timeout;
+
+    ASSERT_LOCK(&io_request_lock, 0);
+
+#if DEBUG
+    unsigned long *ret = 0;
+#ifdef __mips__
+    __asm__ __volatile__ ("move\t%0,$31":"=r"(ret));
+#else
+   ret =  __builtin_return_address(0);
+#endif
+#endif
+
+    host = SCpnt->host;
+
+    /* Assign a unique nonzero serial_number. */
+    if (++serial_number == 0) serial_number = 1;
+    SCpnt->serial_number = serial_number;
+
+    /*
+     * We will wait MIN_RESET_DELAY clock ticks after the last reset so
+     * we can avoid the drive not being ready.
+     */
+    timeout = host->last_reset + MIN_RESET_DELAY;
+
+    if (host->resetting && time_before(jiffies, timeout)) {
+	int ticks_remaining = timeout - jiffies;
+	/*
+	 * NOTE: This may be executed from within an interrupt
+	 * handler!  This is bad, but for now, it'll do.  The irq
+	 * level of the interrupt handler has been masked out by the
+	 * platform dependent interrupt handling code already, so the
+	 * sti() here will not cause another call to the SCSI host's
+	 * interrupt handler (assuming there is one irq-level per
+	 * host).
+	 */
+	while (--ticks_remaining >= 0) mdelay(1+999/HZ);
+	host->resetting = 0;
+    }
+
+    if( host->hostt->use_new_eh_code )
+      {
+        scsi_add_timer(SCpnt, SCpnt->timeout_per_command, scsi_times_out);
+      }
+    else
+      {
+        scsi_add_timer(SCpnt, SCpnt->timeout_per_command, 
+                            scsi_old_times_out);
+      }
+
+    /*
+     * We will use a queued command if possible, otherwise we will emulate the
+     * queuing and calling of completion function ourselves.
+     */
+    SCSI_LOG_MLQUEUE(3,printk("scsi_dispatch_cmnd (host = %d, channel = %d, target = %d, "
+	   "command = %p, buffer = %p, \nbufflen = %d, done = %p)\n",
+	   SCpnt->host->host_no, SCpnt->channel, SCpnt->target, SCpnt->cmnd,
+	   SCpnt->buffer, SCpnt->bufflen, SCpnt->done));
+
+    SCpnt->state = SCSI_STATE_QUEUED;
+    SCpnt->owner = SCSI_OWNER_LOWLEVEL;
+    if (host->can_queue)
+    {
+	SCSI_LOG_MLQUEUE(3,printk("queuecommand : routine at %p\n",
+                                  host->hostt->queuecommand));
+        /*
+         * Use the old error handling code if we haven't converted the driver
+         * to use the new one yet.  Note - only the new queuecommand variant
+         * passes a meaningful return value.
+         */
+        if( host->hostt->use_new_eh_code )
+          {
+            rtn = host->hostt->queuecommand (SCpnt, scsi_done);
+            if( rtn != 0 )
+            {
+                scsi_delete_timer(SCpnt);
+                scsi_mlqueue_insert(SCpnt, SCSI_MLQUEUE_HOST_BUSY);
+            }
+          }
+        else
+          {
+            host->hostt->queuecommand (SCpnt, scsi_old_done);
+          }
+    }
+    else
+    {
+	int temp;
+
+	SCSI_LOG_MLQUEUE(3,printk("command() :  routine at %p\n", host->hostt->command));
+	temp = host->hostt->command (SCpnt);
+	SCpnt->result = temp;
+#ifdef DEBUG_DELAY
+	clock = jiffies + 4 * HZ;
+	while (time_before(jiffies, clock)) barrier();
+	printk("done(host = %d, result = %04x) : routine at %p\n",
+	       host->host_no, temp, host->hostt->command);
+#endif
+        if( host->hostt->use_new_eh_code )
+          {
+            scsi_done(SCpnt);
+          }
+        else
+          {
+            scsi_old_done(SCpnt);
+          }
+    }
+    SCSI_LOG_MLQUEUE(3,printk("leaving scsi_dispatch_cmnd()\n"));
+    return rtn;
+}
+#else
 inline int internal_cmnd (Scsi_Cmnd * SCpnt)
 {
 #ifdef DEBUG_DELAY
@@ -1419,6 +1725,7 @@
     SCSI_LOG_MLQUEUE(3,printk("leaving internal_cmnd()\n"));
     return rtn;
 }
+#endif
 
 /*
  * scsi_do_cmd sends all the commands out to the low-level driver.  It
@@ -1427,6 +1734,32 @@
  * drivers go for the same host at the same time.
  */
 
+/*
+ * Function:    scsi_do_cmd
+ *
+ * Purpose:     Queue a SCSI command
+ *
+ * Arguments:   SCpnt     - command descriptor.
+ *		cmnd      - actual SCSI command to be performed.
+ *              buffer    - data buffer.
+ *              bufflen   - size of data buffer.
+ *              done      - completion function to be run.
+ *              timeout   - how long to let it run before timeout.
+ *              retries   - number of retries we allow.
+ *
+ * Lock status: With the new queueing code, this is SMP-safe, and no locks
+ *              need be held upon entry.   The old queueing code the lock was
+ *              assumed to be held upon entry.
+ *
+ * Returns:     Pointer to command descriptor.
+ *
+ * Notes:	Prior to the new queue code, this function was not SMP-safe.
+ *              Also, this function is now only used for queueing requests
+ *              for things like ioctls and character device requests - this
+ *              is because we essentially just inject a request into the
+ *              queue for the device. Normal block device handling manipulates
+ *              the queue directly.
+ */
 void scsi_do_cmd (Scsi_Cmnd * SCpnt, const void *cmnd ,
 		  void *buffer, unsigned bufflen, void (*done)(Scsi_Cmnd *),
 		  int timeout, int retries)
@@ -1434,6 +1767,8 @@
     struct Scsi_Host * host = SCpnt->host;
     Scsi_Device      * device = SCpnt->device;
 
+    ASSERT_LOCK(&io_request_lock, 0);
+
     SCpnt->owner = SCSI_OWNER_MIDLEVEL;
 
 SCSI_LOG_MLQUEUE(4,
@@ -1464,6 +1799,7 @@
      * ourselves.
      */
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     SCpnt->pid = scsi_pid++;
 
     while (SCSI_BLOCK((Scsi_Device *) NULL, host)) {
@@ -1473,6 +1809,7 @@
     }
 
     if (host->block) host_active = host;
+#endif
 
     host->host_busy++;
     device->device_busy++;
@@ -1513,39 +1850,73 @@
     SCpnt->internal_timeout = NORMAL_TIMEOUT;
     SCpnt->abort_reason = 0;
     SCpnt->result = 0;
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    /*
+     * At this point, we merely set up the command, stick it in the normal
+     * request queue, and return.  Eventually that request will come to the
+     * top of the list, and will be dispatched.
+     */
+    scsi_insert_special_cmd (SCpnt, 0);  
+#else
     internal_cmnd (SCpnt);
+#endif
 
     SCSI_LOG_MLQUEUE(3,printk ("Leaving scsi_do_cmd()\n"));
 }
 
-/* This function is the mid-level interrupt routine, which decides how
+/* 
+ * This function is the mid-level interrupt routine, which decides how
  *  to handle error conditions.  Each invocation of this function must
  *  do one and *only* one of the following:
  *
  *      1) Insert command in BH queue.
  *      2) Activate error handler for host.
  *
- * FIXME(eric) - I am concerned about stack overflow (still).  An interrupt could
- * come while we are processing the bottom queue, which would cause another command
- * to be stuffed onto the bottom queue, and it would in turn be processed as that
- * interrupt handler is returning.  Given a sufficiently steady rate of returning
- * commands, this could cause the stack to overflow.  I am not sure what is the most
- * appropriate solution here - we should probably keep a depth count, and not process
- * any commands while we still have a bottom handler active higher in the stack.
- *
- * There is currently code in the bottom half handler to monitor recursion in the bottom
- * handler and report if it ever happens.  If this becomes a problem, it won't be hard to
- * engineer something to deal with it so that only the outer layer ever does any real
- * processing.
+ * FIXME(eric) - I am concerned about stack overflow (still).  An
+ * interrupt could come while we are processing the bottom queue,
+ * which would cause another command to be stuffed onto the bottom
+ * queue, and it would in turn be processed as that interrupt handler
+ * is returning.  Given a sufficiently steady rate of returning
+ * commands, this could cause the stack to overflow.  I am not sure
+ * what is the most appropriate solution here - we should probably
+ * keep a depth count, and not process any commands while we still
+ * have a bottom handler active higher in the stack.
+ *
+ * There is currently code in the bottom half handler to monitor
+ * recursion in the bottom handler and report if it ever happens.  If
+ * this becomes a problem, it won't be hard to engineer something to
+ * deal with it so that only the outer layer ever does any real
+ * processing.  
  */
 void
 scsi_done (Scsi_Cmnd * SCpnt)
 {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned long flags;
+    int           tstatus;
+#endif
 
   /*
    * We don't have to worry about this one timing out any more.
    */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  tstatus = scsi_delete_timer(SCpnt);
+
+  /*
+   * If we are unable to remove the timer, it means that the command
+   * has already timed out.  In this case, we have no choice but to
+   * let the timeout function run, as we have no idea where in fact
+   * that function could really be.  It might be on another processor,
+   * etc, etc.
+   */
+  if( !tstatus )
+  {
+      return;
+  }
+#else
   scsi_delete_timer(SCpnt);
+#endif
 
   /* Set the serial numbers back to zero */
   SCpnt->serial_number = 0;
@@ -1564,6 +1935,10 @@
       return;
     }
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_lock_irqsave(&scsi_bhqueue_lock, flags);
+#endif
+
   SCpnt->serial_number_at_timeout = 0;
   SCpnt->state = SCSI_STATE_BHQUEUE;
   SCpnt->owner = SCSI_OWNER_BH_HANDLER;
@@ -1579,6 +1954,10 @@
    * We already have the io_request_lock here, since we are called from the
    * interrupt handler or the error handler. (DB)
    *
+   * This may be true at the moment, but I would like to wean all of the low
+   * level drivers away from using io_request_lock.   Technically they should
+   * all use their own locking.  I am adding a small spinlock to protect
+   * this datastructure to make it safe for that day.  (ERY)
    */
   if (!scsi_bh_queue_head) {
   	scsi_bh_queue_head = SCpnt;
@@ -1587,6 +1966,9 @@
   	scsi_bh_queue_tail->bh_next = SCpnt;
   	scsi_bh_queue_tail = SCpnt;
   }
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_unlock_irqrestore(&scsi_bhqueue_lock, flags);
+#endif
 
   /*
    * Mark the bottom half handler to be run.
@@ -1609,6 +1991,13 @@
  * race condition when scsi_done is called after a command has already
  * timed out but before the time out is processed by the error handler.
  * (DB)
+ *
+ * I believe I have corrected this.  We simply monitor the return status of
+ * del_timer() - if this comes back as 0, it means that the timer has fired
+ * and that a timeout is in progress.   I have modified scsi_done() such
+ * that in this instance the command is never inserted in the bottom
+ * half queue.  Thus the only time we hold the lock here is when
+ * we wish to atomically remove the contents of the queue.
  */
 void scsi_bottom_half_handler(void)
 {
@@ -1616,15 +2005,25 @@
   Scsi_Cmnd        * SCnext;
   unsigned long      flags;
   
+#ifndef CONFIG_SCSI_NEW_QUEUES
   spin_lock_irqsave(&io_request_lock, flags);
+#endif
 
   while(1==1)
   {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+      spin_lock_irqsave(&scsi_bhqueue_lock, flags);
+#endif
       SCpnt = scsi_bh_queue_head;
       scsi_bh_queue_head = NULL;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+      spin_unlock_irqrestore(&scsi_bhqueue_lock, flags);
+#endif
       
       if( SCpnt == NULL ) {
+#ifndef CONFIG_SCSI_NEW_QUEUES
           spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
           return;
           }
       
@@ -1717,9 +2116,9 @@
       } /* for(; SCpnt...) */
 
   } /* while(1==1) */
-
+#ifndef CONFIG_SCSI_NEW_QUEUES
   spin_unlock_irqrestore(&io_request_lock, flags);
-
+#endif
 }
 
 /*
@@ -1741,9 +2140,13 @@
   SCpnt->request_bufflen = SCpnt->bufflen;
   SCpnt->use_sg = SCpnt->old_use_sg;
   SCpnt->cmd_len = SCpnt->old_cmd_len;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  return scsi_dispatch_cmd (SCpnt);
+#else
   SCpnt->result = 0;
   memset ((void *) SCpnt->sense_buffer, 0, sizeof SCpnt->sense_buffer);
   return internal_cmnd (SCpnt);
+#endif
 }
 
 /*
@@ -1759,12 +2162,15 @@
     struct Scsi_Host * host;
     Scsi_Device * device;
 
+    ASSERT_LOCK(&io_request_lock, 0);
+
     host = SCpnt->host;
     device = SCpnt->device;
 
     host->host_busy--; /* Indicate that we are free */
     device->device_busy--; /* Decrement device usage counter. */
   
+#ifndef CONFIG_SCSI_NEW_QUEUES
     if (host->block && host->host_busy == 0) 
     {
         host_active = NULL;
@@ -1790,6 +2196,7 @@
     }
 
     wake_up(&host->host_wait);
+#endif
     
     /*
      * If we have valid sense information, then some kind of recovery
@@ -1817,16 +2224,47 @@
 static void scsi_unregister_host(Scsi_Host_Template *);
 #endif
 
+/*
+ * Function:    scsi_malloc
+ *
+ * Purpose:     Allocate memory from the DMA-safe pool.
+ *
+ * Arguments:   len       - amount of memory we need.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Pointer to memory block.
+ *
+ * Notes:	Prior to the new queue code, this function was not SMP-safe.
+ *              This function can only allocate in units of sectors
+ *              (i.e. 512 bytes).
+ *
+ *              We cannot use the normal system allocator becuase we need
+ *              to be able to guarantee that we can process a complete disk
+ *              I/O request without touching the system allocator.  Think
+ *              about it - if the system were heavily swapping, and tried to
+ *              write out a block of memory to disk, and the SCSI code needed
+ *              to allocate more memory in order to be able to write the
+ *              data to disk, you would wedge the system.
+ */
 void *scsi_malloc(unsigned int len)
 {
     unsigned int nbits, mask;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned long flags;
+#endif
     int i, j;
+
     if(len % SECTOR_SIZE != 0 || len > PAGE_SIZE)
 	return NULL;
 
     nbits = len >> 9;
     mask = (1 << nbits) - 1;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_lock_irqsave(&allocator_request_lock, flags);
+#endif
+
     for(i=0;i < dma_sectors / SECTORS_PER_PAGE; i++)
 	for(j=0; j<=SECTORS_PER_PAGE - nbits; j++){
 	    if ((dma_malloc_freelist[i] & (mask << j)) == 0){
@@ -1836,15 +2274,43 @@
                 SCSI_LOG_MLQUEUE(3,printk("SMalloc: %d %p [From:%p]\n",len, dma_malloc_pages[i] + (j << 9)));
 		printk("SMalloc: %d %p [From:%p]\n",len, dma_malloc_pages[i] + (j << 9));
 #endif
+#ifdef CONFIG_SCSI_NEW_QUEUES
+                spin_unlock_irqrestore(&allocator_request_lock, flags);
+#endif
 		return (void *) ((unsigned long) dma_malloc_pages[i] + (j << 9));
 	    }
 	}
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_unlock_irqrestore(&allocator_request_lock, flags);
+#endif
     return NULL;  /* Nope.  No more */
 }
 
+/*
+ * Function:    scsi_free
+ *
+ * Purpose:     Free memory into the DMA-safe pool.
+ *
+ * Arguments:   ptr       - data block we are freeing.
+ *              len       - size of block we are freeing.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Nothing
+ *
+ * Notes:	This function *must* only be used to free memory
+ *              allocated from scsi_malloc().
+ *
+ *              Prior to the new queue code, this function was not SMP-safe.
+ *              This function can only allocate in units of sectors
+ *              (i.e. 512 bytes).
+ */
 int scsi_free(void *obj, unsigned int len)
 {
     unsigned int page, sector, nbits, mask;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned long flags;
+#endif
 
 #ifdef DEBUG
     unsigned long ret = 0;
@@ -1858,6 +2324,10 @@
     SCSI_LOG_MLQUEUE(3,printk("SFree: %p %d\n",obj, len));
 #endif
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_lock_irqsave(&allocator_request_lock, flags);
+#endif
+
     for (page = 0; page < dma_sectors / SECTORS_PER_PAGE; page++) {
         unsigned long page_addr = (unsigned long) dma_malloc_pages[page];
         if ((unsigned long) obj >= page_addr &&
@@ -1881,6 +2351,9 @@
             }
             scsi_dma_free_sectors += nbits;
             dma_malloc_freelist[page] &= ~(mask << sector);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+            spin_unlock_irqrestore(&allocator_request_lock, flags);
+#endif
             return 0;
 	}
     }
@@ -1933,10 +2406,17 @@
 
 void scsi_build_commandblocks(Scsi_Device * SDpnt)
 {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned long flags;
+#endif
     struct Scsi_Host *host = SDpnt->host;
     int j;
     Scsi_Cmnd * SCpnt;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_lock_irqsave(&device_request_lock, flags);
+#endif
+
     if (SDpnt->queue_depth == 0)
         SDpnt->queue_depth = host->cmd_per_lun;
     SDpnt->device_queue = NULL;
@@ -1977,6 +2457,9 @@
 	/* Still problem if 0==j , continue anyway ... */
     }
     SDpnt->has_cmdblocks = 1;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_unlock_irqrestore(&device_request_lock, flags);
+#endif
 }
 
 #ifndef MODULE /* { */
@@ -2417,6 +2900,9 @@
                 HBA_ptr->host_queue = scd->next;
             }
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+            blk_cleanup_queue(&scd->request_queue);
+#endif
             scsi_init_free((char *) scd, sizeof(Scsi_Device));
         } else {
             return(-EBUSY);
@@ -2428,13 +2914,29 @@
 #endif
 
 /*
- * Go through the device list and recompute the most appropriate size
- * for the dma pool.  Then grab more memory (as required).
+ * Function:    resize_dma_pool
+ *
+ * Purpose:     Ensure that the DMA pool is sufficiently large to be
+ *              able to guarantee that we can always process I/O requests
+ *              without calling the system allocator.
+ *
+ * Arguments:   None.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Nothing
+ *
+ * Notes:	Prior to the new queue code, this function was not SMP-safe.
+ *              Go through the device list and recompute the most appropriate
+ *              size for the dma pool.  Then grab more memory (as required).
  */
 static void resize_dma_pool(void)
 {
     int i;
     unsigned long size;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned long flags;
+#endif
     struct Scsi_Host * shpnt;
     struct Scsi_Host * host = NULL;
     Scsi_Device * SDpnt;
@@ -2443,6 +2945,10 @@
     unsigned int new_need_isa_buffer = 0;
     unsigned char ** new_dma_malloc_pages = NULL;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_lock_irqsave(&allocator_request_lock, flags);
+#endif
+
     if( !scsi_hostlist )
     {
 	/*
@@ -2463,6 +2969,9 @@
 	dma_malloc_freelist = NULL;
 	dma_sectors = 0;
 	scsi_dma_free_sectors = 0;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+        spin_unlock_irqrestore(&allocator_request_lock, flags);
+#endif
 	return;
     }
     /* Next, check to see if we need to extend the DMA buffer pool */
@@ -2579,6 +3088,10 @@
     dma_sectors = new_dma_sectors;
     scsi_need_isa_buffer = new_need_isa_buffer;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    spin_unlock_irqrestore(&allocator_request_lock, flags);
+#endif
+
 #ifdef DEBUG_INIT
     printk("resize_dma_pool: dma free sectors   = %d\n", scsi_dma_free_sectors);
     printk("resize_dma_pool: dma sectors        = %d\n", dma_sectors);
@@ -2659,8 +3172,8 @@
                 
                 shpnt->eh_notify = &sem;
                 kernel_thread((int (*)(void *))scsi_error_handler, 
-                              (void *) shpnt, 0);
-                
+                              (void *) shpnt, 0);                
+
                 /*
                  * Now wait for the kernel error thread to initialize itself
                  * as it might be needed when we scan the bus.
@@ -2690,7 +3203,9 @@
 	printk ("scsi : %d host%s.\n", next_scsi_host,
 		(next_scsi_host == 1) ? "" : "s");
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	scsi_make_blocked_list();
+#endif
 
 	/* The next step is to call scan_scsis here.  This generates the
 	 * Scsi_Devices entries
@@ -2921,6 +3436,9 @@
             }
             SDpnt->has_cmdblocks = 0;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+            blk_cleanup_queue(&SDpnt->request_queue);
+#endif
             /* Next free up the Scsi_Device structures for this host */
             shpnt->host_queue = SDpnt->next;
 	    scsi_init_free((char *) SDpnt, sizeof (Scsi_Device));
@@ -2978,7 +3496,9 @@
 	    (scsi_memory_upper_value - scsi_init_memory_start) / 1024);
 #endif
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     scsi_make_blocked_list();
+#endif
 
     /* There were some hosts that were loaded at boot time, so we cannot
        do any more than this */
@@ -3211,12 +3731,11 @@
     i = 0;
     for(shpnt = scsi_hostlist; shpnt; shpnt = shpnt->next)
     {
-        printk(" %d %d %d : %d %p\n",
+        printk(" %d %d %d : %d\n",
                shpnt->host_failed,
                shpnt->host_busy,
                atomic_read(&shpnt->host_active),
-               shpnt->host_blocked,
-               shpnt->pending_commands);
+               shpnt->host_blocked);
 
     }
 
@@ -3268,11 +3787,11 @@
             printk("Dump of pending block device requests\n");
             for(i=0; i<MAX_BLKDEV; i++)
             {
-                if(blk_dev[i].current_request)
+                if(blk_dev[i].request_queue.current_request)
                 {
                     struct request * req;
                     printk("%d: ", i);
-                    req = blk_dev[i].current_request;
+                    req = blk_dev[i].request_queue.current_request;
                     while(req) 
                     {
                         printk("(%s %d %ld %ld %ld) ",
@@ -3288,7 +3807,7 @@
             }
         }
     }
-    printk("wait_for_request = %p\n", wait_for_request);
+    printk("wait_for_request = %p\n", &wait_for_request);
 #endif /* CONFIG_SCSI_LOGGING */ /* } */
 #endif /* CONFIG_PROC_FS */
 }
